It is not possible to upgrade original English version to selected localized version. You can install English version of 3.4.2 and add define(‘WPLANG’, ‘cs_CZ’); into wp-config.php. After uploading localized files into wp-content/languages is WordPress install localized.

But it is not possible to update to Czech version of WordPress 3.5. There is only English version available. It is regression, because it was possible several months ago. Now there is no chance to update to localized version and several Czech users had troubles with this behaviour. So, when you start working in English and want to switch to localized version, automatic updates will not work. Never. Too bad… Could you please look at it?

Trac: http://core.trac.wordpress.org/ticket/23113